/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BIT_FREQUENCY_MODIFIER__
#define __DD_BIT_FREQUENCY_MODIFIER__

#include "DDFrequencyModifier.h"

namespace double_description {

    class BitFrequencyModifier : public FrequencyModifier {

        protected:
        unsigned long update ( const unsigned long index, const bool value ) const {
            return value ? mPopulation[ index ].count() : 0;
        }

        public:
        BitFrequencyModifier( const std::vector<BitPopulationEntry> & population ) :
            FrequencyModifier( population ) {}
    };
}

#endif // __DD_BIT_FREQUENCY_MODIFIER__
