/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_MATRIX_UTILS__
#define __DD_MATRIX_UTILS__

#include <cstring>

#include "DDMatrix.h"
#include "DDCalcModule.h"

namespace double_description {

	class MatrixUtils {
		
		private:
		CalcModule& mCalcModule;

		public:
		MatrixUtils ( CalcModule& calcModule );

		const Matrix applyNemhauserWolsey ( Matrix& matrix );
		const Matrix applyPositiveBaseTransformation ( const Matrix& matrix );

		static Matrix getIdentityMatrix ( const unsigned long dimension ) {
			Matrix identity( dimension, dimension );

			for ( unsigned long i = 0; i < dimension; i++ ) {
				identity.setValue( i, i, 1 );
			}

			return identity;
		}
	};
}

#endif // __DD_MATRIX_UTILS__
