/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_REFERENCE_CONTAINER__
#define __DD_REFERENCE_CONTAINER__

namespace double_description {

	struct RayReference {
		const void * ray;
		const BitList * activeSet;

		RayReference() :
			ray( NULL ),
			activeSet( NULL ) {}

		RayReference( const void * r, const BitList * s ) :
			ray( r ),
			activeSet( s ) {}

		void operator= ( const RayReference & other ) {
			ray = other.ray;
			activeSet = other.activeSet;
		}
	};

    class ReferenceContainer {
        
        private:
        const RayReference * mRefs;

        const unsigned long mPosRefsCount;
        const unsigned long mNegRefsCount;
        const unsigned long mZeroRefsCount;

        const BitList mPosRefsMap;
        const BitList mNegRefsMap;
        const BitList mZeroRefsMap;
    };
}

#endif // __DD_REFERENCE_CONTAINER__
