/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_VERIFICATION_TRAVERSE_VISITOR__
#define __DD_VERIFICATION_TRAVERSE_VISITOR__

#include <deque>
#include <vector>

#include "DDTreeNode.h"
#include "DDPreliminaryTraverseVisitor.h"

namespace double_description {

    class VerificationTraverseVisitor : public PreliminaryTraverseVisitor {

        private:
        const TreeNode & mVerificator;

        public:
        VerificationTraverseVisitor( const TreeNode & tree,
                                     const TreeNode & verificator,
                                     const unsigned short bits ) :
            PreliminaryTraverseVisitor( tree, bits ),
            mVerificator( verificator ) {}

        void onVisit ( const struct RayReference & current ) {
            RayRefVisitor::onVisit( current );

            mTree.preliminaryTraverse( current, mCandidates, mVerificator );
        }

    };
}

#endif // __DD_VERIFICATION_TRAVERSE_VISITOR__
